sub sethint_type1 {
    my $font = shift;
    my $flag = 0;
    my $line;
    my @lines;
    my $fontname = '';
    my $fullname = '';
    my @fullnamelist = ();
    my $family = '';
    my $generalfamily;
    my $weight = '';
    my $width = '';
    my $shape;
    my $slant;
    my $serif = '';
    my $swidth;
    my $text;
    my $encoding = '';
    my $charset;

    my $fontfilename = $font;
    $fontfilename =~ s/.*\/(.*)/$1/;

    open(F, $font) || die "$font: Unable to open.\n";

    $line = scalar(<F>);
    if ($line =~ /^.*\r.*/) {
	$line =~ s/\r/\n/g;
	while ($line =~ /.*\n/) {
	    push(@lines, $&);
	    $line = $';
	}
    }

    while (<F>) {
	if (@lines > 0) {
	    $line = shift(@lines);
	} else {
	    $line = $_;
	}

	last if ($line =~ /currentdict[ \t]+end/);

	if ($line =~ /\/FullName[ \t\(]/) {
	    $fullname = $line;
	    $fullname =~ s/.*\/FullName[ \t]*\((.*)\).*\n/$1/;
	    @fullnamelist = split(/ +/, $fullname);
	} elsif ($line =~ /\/FamilyName[ \t\(]/) {
	    $family = $line;
	    $family =~ s/.*\/FamilyName[ \t]*\((.*)\).*\n/$1/;
	} elsif ($line =~ /\/Weight[ \t\(]/) {
	    $weight = $line;
	    $weight =~ s/.*\/Weight[ \t]*\((.*)\).*\n/$1/;
	} elsif ($line =~ /\/isFixedPitch[ \t]+true[ \t]/) {
	    $width = 'Fixed';
	} elsif ($line =~ /\/isFixedPitch[ \t]+false[ \t]/) {
	    $width = 'Variable';
	} elsif ($line =~ /\/FontName[ \t\/]/) {
	    $fontname = $line;
	    $fontname =~ s/.*\/FontName[ \t]*\/([^ \t]+)[ \t].*\n/$1/;
	} elsif ($line =~ /\/Encoding[ \t]/) {
	    $encoding = $line;
	    $encoding =~ s/.*\/Encoding[ \t]+([^ \t]+)[ \t].*\n/$1/;
	}
    }

    if ($fontname eq '') {
	die "Some information aren't found in $fontfilename.\nAborting..";
    }

    $fontname =~ s/ /_/g;
    $family =~ s/ /_/g;
    $weight =~ s/ /_/g;

    $slant = 'Upright';
    $swidth = '';
    for (my $i = 0; $i < @fullnamelist; $i++) {
	$slant = 'Italic' if ($fullnamelist[$i] eq 'Italic');
	$slant = 'Oblique' if ($fullnamelist[$i] eq 'Oblique');
	$swidth = 'Condensed' if ($fullnamelist[$i] eq 'Condensed');
	$swidth = 'Expanded' if ($fullnamelist[$i] eq 'Expanded');
    }

    $encoding =~ s/Encoding$//;
    $charset = 'font-specific';
    $charset = 'ISO8859-1' if ($encoding =~ /^(Standard|ISOLatin1)$/);

    msgbox("Charset of $fontname is $charset.");

    $family = input_family($fontname, $family);
    return if ($result != 0);

    $generalfamily = input_generalfamily($fontname, $family);
    return if ($result != 0);
    $serif = 'NoSerif' if ($generalfamily eq 'SansSerif');
    $width = 'Fixed' if ($generalfamily eq 'Typewriter');

    $weight = input_weight($fontname, $weight);
    return if ($result != 0);

    $width = input_width($fontname, $width);
    return if ($result != 0);

    $shape = "$swidth $slant $serif";
    $shape = input_shape($fontname, "$slant $serif $swidth");
    return if ($result != 0);

    my $alias = input_alias($fontname, '');
    return if ($result != 0);

    my $priority = input_priority($fontname, 20);
    return if ($result != 0);

    my $xlfd = input_xlfd($fontname);
    return if ($result != 0);

    my $hints = "--FontName $fontname";
    $hints .= " --Charset $charset";
    $hints .= " --Family $family";
    $hints .= " --GeneralFamily $generalfamily" if ($generalfamily ne '');
    $hints .= " --Weight $weight" if ($weight ne '');
    $hints .= " --Width $width" if ($width ne '');
    $hints .= " --Shape $shape" if ($shape ne '');
    $hints .= " --Alias $alias" if ($alias ne '');
    $hints .= " --Priority $priority";
    $hints .= " --X-FontName $xlfd" if ($xlfd ne '');
    
    $hints =~ s/\t/ /;
    $hints =~ s/ +/ /;

    return $hints;
}

1;
